#!/bin/sh

# Fixups to the copy_segments function
# One and only arg is path to kernel source

# We extract the function from the relevant source file
# - rename to skas_copy_segments
# - change first argument to mm_struct* old_mm
# - remove declaration and initialisation of old_mm

./extractfunction.sh \
   'void copy_segments' \
         < $1/arch/i386/kernel/process.c | \
sed 's/void copy_segments([^,]*/static inline void skas_copy_segments(struct mm_struct *old_mm/' | \
sed 's/.*struct mm_struct \* old_mm;.*//'                                          | \
sed 's/.*current->mm.*//'
