#!/bin/sh

# Fixups to the do_mmap2 function
# One and only arg is path to kernel source

# We extract the function from the relevant source file
# - rename to skas_mmap2
# - add first argument of struct *mm
# - change 'current->mm' to mm
# - change call to do_mmap_pgoff to skas_do_mmap_pgoff,
#     and make first param be mm

./extractfunction.sh \
   'static inline long do_mmap2' \
         < $1/arch/i386/kernel/sys_i386.c | \
sed 's/long do_mmap2(/long skas_mmap2(struct mm_struct *mm,/' | \
sed 's/current->mm/mm/'                                       | \
sed 's/do_mmap_pgoff(/skas_do_mmap_pgoff(mm, /'