#!/bin/sh

# Fixups to the mprotect function
# One and only arg is path to kernel source

# We extract the function from the relevant source file
# - rename to skas_mprotect
# - add first argument of struct *mm
# - change 'current->mm' to mm
# - change from asmlinkage to static inline

cat <<EOF
/* A function we call */
extern int mprotect_fixup(struct vm_area_struct * vma, 
			    struct vm_area_struct ** pprev,
	    unsigned long start, unsigned long end, unsigned int newflags);
EOF

./extractfunction.sh \
   'asmlinkage long sys_mprotect' \
         < $1/mm/mprotect.c | \
sed 's/asmlinkage long sys_mprotect(/static inline long skas_mprotect(struct mm_struct *mm,/' | \
sed 's/current->mm/mm/'