extern int skas_modify_ldt(struct task_struct *task, int func, void *ptr, 
		      unsigned long bytecount);

extern struct mm_struct *proc_mm_get_mm(int fd);

asmlinkage int sys_ptrace(long request, long pid, long addr, long data)
{
	struct task_struct *child;
...
			child->ptrace |= PT_TRACESYSGOOD;
		else
			child->ptrace &= ~PT_TRACESYSGOOD;
		ret = 0;
		break;
	}

	case PTRACE_FAULTINFO: {
		struct ptrace_faultinfo fault;

		fault = ((struct ptrace_faultinfo) 
			{ .is_write	= child->thread.error_code,
			  .addr		= child->thread.cr2 });
		ret = copy_to_user((unsigned long *) data, &fault, 
				   sizeof(fault));
		if(ret)
			break;
		break;
	}
	case PTRACE_SIGPENDING:
		ret = copy_to_user((unsigned long *) data, 
				   &child->pending.signal,
				   sizeof(child->pending.signal));
		break;

	case PTRACE_LDT: {
		struct ptrace_ldt ldt;

		if(copy_from_user(&ldt, (unsigned long *) data, 
				  sizeof(ldt))){
			ret = -EIO;
			break;
		}
		ret = skas_modify_ldt(child, ldt.func, ldt.ptr, ldt.bytecount);
		break;
	}

	case PTRACE_SWITCH_MM: {
		struct mm_struct *old = child->mm;
		struct mm_struct *new = proc_mm_get_mm(data);

		if(IS_ERR(new)){
			ret = PTR_ERR(new);
			break;
		}

		atomic_inc(&new->mm_users);
		child->mm = new;
		child->active_mm = new;
		mmput(old);
		ret = 0;
		break;
	}
